;***************************
;*** alexei-developer.ru ***
;***************************

.include "tn2313def.inc"


;/////////////////
;///  ///
;/////////////////

; RS-232
.equ XTAL = 4000000
.equ BAUDRATE = 9600  
.equ bauddivider = XTAL/(16*BAUDRATE)-1

; 
.equ zaderzhka_pwm = 0 ;   
.equ step_dec_pwm = 5 ;   

.equ volt_correct = 20 ;   

;    
.equ timeBinBcd_H = 0x00+0x01
.equ timeBinBcd_L = 0x0F


;//////////////////
;///  ///
;//////////////////

; 
.def t1 = R16;
.def t2 = R17;

;
.def lev_pwm = R18 ;
.def counter_zaderzhka = R19 ; (  ) 

;     
.def LED_bin_value = R20 ;       
			 ;   

.def LED_bin_value_H = R25 ; 
.def LED_bin_value_L = R20

.def LED7segment_1 = R21 ; 
.def LED7segment_2 = R22

;     
.def TimerBinBcd_H = R23 
.def TimerBinBcd_L = R24


.cseg

;//////////////////
;///  ///
;//////////////////

.org $000 ;RESET ; Reset Handler
 	RJMP RESET 
.org $001 ;INT0 ; External Interrupt0 Handler
 	RETI
.org $002 ;INT1 ; External Interrupt1 Handler
 	RETI
.org $003 ;TIM1_CAPT ; Timer1 Capture Handler
 	RETI
.org $004 ;TIM1_COMPA ; Timer1 CompareA Handler
	RETI
.org $005 ;TIM1_OVF ; Timer1 Overflow Handler
	RETI	
.org $006 ;TIM0_OVF ; Timer0 Overflow Handler
	RJMP PWM
.org $007 ;USART0_RXC ; USART0 RX Complete Handler
 	RETI
.org $008 ;USART0_DRE ; USART0,UDR Empty Handler
 	RETI
.org $009 ;USART0_TXC ; USART0 TX Complete Handler
 	RETI
.org $00A ;ANA_COMP ; Analog Comparator Handler
 	RJMP ANALOG_COMP_RAVNO
.org $00B ;PCINT ; Pin Change Interrupt
 	RETI
.org $00C ;TIMER1_COMPB ; Timer1 Compare B Handler
 	RETI
.org $00D ;TIMER0_COMPA ; Timer0 Compare A Handler
 	RETI
.org $00E ;TIMER0_COMPB ; Timer0 Compare B Handler
 	RETI
.org $00F ;USI_START ; USI Start Handler
 	RETI
.org $010 ;USI_OVERFLOW ; USI Overflow Handler
 	RETI
.org $011 ;EE_READY ; EEPROM Ready Handler
 	RETI
.org $012 ;WDT_OVERFLOW ; Watchdog Overflow Handler 
 	RETI 

.ORG   INT_VECTORS_SIZE      	;   


;////////////////////////
;///  "" ///
;////////////////////////

.include "init.asm"
.include "interrupt.asm"

.include "subprograms.asm"
.include "macros.asm"


;////////////////////////////////
;///   ///
;////////////////////////////////

RESET:

ldi t1, low(RAMEND); Main program start
out SPL,t1 ;Set Stack Pointer to top of RAM

LDI lev_pwm, 0
LDI counter_zaderzhka, 0

RCALL ports_init
RCALL pwm_init
RCALL analog_comp_init
;RCALL disp_init
;RCALL uart_init

SEI ; 

LDI TimerBinBcd_H, timeBinBcd_H
LDI TimerBinBcd_L, timeBinBcd_L


;//////////////////////////
;///   ///
;//////////////////////////

beg:

	;=======================
	;===   ===
	;=======================

	; 
	CBI PORTB, 3
	CBI PORTB, 4

	;   
	;LDI t1, 3
	MOV t1, LED7segment_1
	RCALL DecTo7LedPort

	;   
	CBI PORTB, 3
	SBI PORTB, 4

	;   
	loop

	;=======================
	;===   ===
	;=======================
	
	; 
	CBI PORTB, 3
	CBI PORTB, 4

	;   
	;LDI t1, 5
	MOV t1, LED7segment_2
	RCALL DecTo7LedPort

	;   
	SBI PORTB, 3
	CBI PORTB, 4

	;   
	loop
	
	;============================================
	;===      ===
	;============================================

	;   
	SUBI TimerBinBcd_L, 1
	BRNE end
	SUBI TimerBinBcd_H, 1
	BRNE not_nul_TimerBinBcd_H
	
;         - 
binbcd:
	cli
	LDI TimerBinBcd_H, timeBinBcd_H

	MOV t1, LED_bin_value_L
	MOV t2, LED_bin_value_H
	RCALL bin2bcd2REG
	sei

not_nul_TimerBinBcd_H:
	LDI TimerBinBcd_L, timeBinBcd_L

end:
	;
	RJMP beg

